#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2000seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 2000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2000seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven20004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven20004xi = {
                1:'-101x-1931y508z',
                2:'-1020x-1571y699z',
                3:'-1022x-1718y4z',
                4:'-1043x-1304y1099z',
                5:'-1097x-1510y718z',
                6:'-1103x-1239y1116z',
                7:'-1110x-1662y24z',
                8:'-1158x-1172y1133z',
                9:'-1170x-1445y736z',
                10:'-1196x-1602y44z',
                11:'-1209x-1102y1149z',
                12:'-1239x-1376y755z',
                13:'-1256x-1030y1165z',
                14:'-1277x-1537y64z',
                15:'-1299x-955y1182z',
                16:'-1304x-1304y773z',
                17:'-132x-999y1727z',
                18:'-1337x-880y1198z',
                19:'-1356x-1467y84z',
                20:'-1364x-1228y792z',
                21:'-1371x-802y1214z',
                22:'-1400x-724y1229z',
                23:'-1420x-1150y810z',
                24:'-1425x-644y1245z',
                25:'-1430x-1393y104z',
                26:'-1445x-564y1261z',
                27:'-1461x-484y1276z',
                28:'-1472x-1069y828z',
                29:'-1472x-403y1292z',
                30:'-1478x-323y1307z',
                31:'-1500x-1316y124z',
                32:'-1519x-986y846z',
                33:'-1561x-901y864z',
                34:'-1566x-1235y144z',
                35:'-1598x-814y882z',
                36:'-1627x-1150y164z',
                37:'-1631x-726y900z',
                38:'-1658x-636y918z',
                39:'-1680x-546y936z',
                40:'-1684x-1062y184z',
                41:'-1697x-454y953z',
                42:'-1710x-363y971z',
                43:'-1717x-271y988z',
                44:'-1718x-180y1006z',
                45:'-1735x-972y204z',
                46:'-175x-1772y909z',
                47:'-1782x-879y224z',
                48:'-181x-974y1737z',
                49:'-1823x-783y244z',
                50:'-1859x-686y263z',
                51:'-1890x-587y283z',
                52:'-18x-19y1999z',
                53:'-1915x-486y303z',
                54:'-19x-285y1979z',
                55:'-201x-1918y528z',
                56:'-228x-946y1747z',
                57:'-266x-1751y927z',
                58:'-272x-916y1756z',
                59:'-28x-1042y1706z',
                60:'-300x-1899y547z',
                61:'-30x-36y1999z',
                62:'-314x-884y1766z',
                63:'-31x-264y1982z',
                64:'-353x-850y1775z',
                65:'-356x-1726y945z',
                66:'-389x-814y1784z',
                67:'-398x-1876y566z',
                68:'-40x-53y1998z',
                69:'-423x-777y1793z',
                70:'-42x-242y1984z',
                71:'-443x-1695y962z',
                72:'-453x-738y1802z',
                73:'-481x-699y1810z',
                74:'-48x-72y1998z',
                75:'-494x-1847y585z',
                76:'-4x-305y1976z',
                77:'-506x-658y1819z',
                78:'-50x-220y1987z',
                79:'-528x-1660y980z',
                80:'-528x-617y1827z',
                81:'-547x-575y1835z',
                82:'-54x-91y1997z',
                83:'-559x-103y1917z',
                84:'-563x-533y1843z',
                85:'-56x-198y1989z',
                86:'-571x-136y1911z',
                87:'-576x-491y1850z',
                88:'-582x-171y1905z',
                89:'-586x-449y1858z',
                90:'-589x-1813y604z',
                91:'-590x-208y1899z',
                92:'-594x-407y1865z',
                93:'-596x-246y1893z',
                94:'-598x-365y1872z',
                95:'-599x-285y1886z',
                96:'-59x-112y1995z',
                97:'-5x-4y1999z',
                98:'-600x-325y1879z',
                99:'-60x-176y1991z',
                100:'-611x-1621y997z',
                101:'-61x-133y1994z',
                102:'-62x-154y1993z',
                103:'-680x-1774y623z',
                104:'-691x-1578y1015z',
                105:'-764x-644y1732z',
                106:'-768x-1530y1032z',
                107:'-770x-1730y642z',
                108:'-779x-730y1808z',
                109:'-783x-593y1741z',
                110:'-798x-541y1751z',
                111:'-810x-490y1761z',
                112:'-819x-438y1770z',
                113:'-81x-1022y1717z',
                114:'-825x-387y1779z',
                115:'-828x-337y1788z',
                116:'-83x-1788y892z',
                117:'-842x-1479y1049z',
                118:'-856x-1681y661z',
                119:'-913x-1424y1066z',
                120:'-940x-1628y680z',
                121:'-980x-1365y1083z',
                122:'0x-1939y489z'}         
         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2000seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2000seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2000SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE2000SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2000SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2000SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2000SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven20004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2000SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2000SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2000SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven20004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven20004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2000SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2000SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2000SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2000seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       